public class Pulse 
{
    SinOsc pulse => ADSR pulseADSR => Gain g => dac;
    pulseADSR.set(10::ms, 250::ms, 0.1, 10::ms);
    //Noise n => HPF hpf => Gain g => dac;
    //g.gain(0.1);
    //hpf.freq(1000);
    fun void trigger(float duration)
    {
        200 => pulse.freq;
        now + (duration*.8)::ms => time later;
        pulseADSR.keyOn();
        while (now < later)
        {
            pulse.freq() * .85 => pulse.freq;
            //g.gain() * .5 => g.gain;
            //pulse.gain() * .99 => pulse.gain;
            10::ms => now;
        }
        pulseADSR.keyOff();
    }
    fun void gain(float gain)
    {
        // Clamp gain between 0 and 1
        if (gain < 0.0) {
            0.0 => gain;
        } else if (gain > 1.0) {
            1.0 => gain;
        }
        gain => g.gain;
    }
}

/*
// Testing
Pulse p;
p.trigger();
1::second => now;
*/